>From 5677e66737e277fac0f2ad6db199f22f0d6ce356 Mon Sep 17 00:00:00 2001
From: Claude Heiland-Allen <claude@mathr.co.uk>
Date: Fri, 22 Aug 2014 12:28:19 +0100
Subject: [PATCH] replace obsolete email address

---
 examples/13.recursion/01.repetition_is_futile.pd      |    2 +-
 examples/13.recursion/02.iteration_is_insufficient.pd |    2 +-
 examples/13.recursion/03.recursive_spiral.pd          |    2 +-
 examples/13.recursion/04.binary_tree.pd               |    2 +-
 examples/13.recursion/05.n-ary_tree.pd                |    2 +-
 examples/13.recursion/06.breaking_symmetry.pd         |    2 +-
 examples/13.recursion/README                          |    2 +-
 examples/13.recursion/nnrepeat.pd                     |    2 +-
 examples/13.recursion/nrepeat.pd                      |    2 +-
 examples/13.recursion/stack-help.pd                   |    2 +-
 examples/13.recursion/stack.pd                        |    2 +-
 11 files changed, 11 insertions(+), 11 deletions(-)

diff --git a/examples/13.recursion/01.repetition_is_futile.pd b/examples/13.recursion/01.repetition_is_futile.pd
index 3b8637b..2fe7232 100644
--- a/examples/13.recursion/01.repetition_is_futile.pd
+++ b/examples/13.recursion/01.repetition_is_futile.pd
@@ -26,7 +26,7 @@
 #X obj 14 483 t a a;
 #X obj 59 483 circle;
 #X text 170 17 A tutorial on recursion in Gem;
-#X text 170 37 (GPL) 2007 Claude Heiland-Allen <claudiusmaximus@goto10.org>
+#X text 170 37 (GPL) 2007 Claude Heiland-Allen <claude@mathr.co.uk>
 ;
 #X text 170 77 The simplest and most obvious way of working with Gem
 is to create all the objects statically. That is \, the Gem chain (or
diff --git a/examples/13.recursion/02.iteration_is_insufficient.pd b/examples/13.recursion/02.iteration_is_insufficient.pd
index f895aff..fad24c1 100644
--- a/examples/13.recursion/02.iteration_is_insufficient.pd
+++ b/examples/13.recursion/02.iteration_is_insufficient.pd
@@ -11,7 +11,7 @@
 #X obj 14 183 rotate 45 0 0 1;
 #X obj 14 203 translate 2 0 1 0;
 #X text 170 17 A tutorial on recursion in Gem;
-#X text 170 37 (GPL) 2007 Claude Heiland-Allen <claudiusmaximus@goto10.org>
+#X text 170 37 (GPL) 2007 Claude Heiland-Allen <claude@mathr.co.uk>
 ;
 #X text 170 77 A common idiom in Gem is to use the [repeat] object
 found in the Zexy library \, to generate multiple copies of the same
diff --git a/examples/13.recursion/03.recursive_spiral.pd b/examples/13.recursion/03.recursive_spiral.pd
index f889aed..2783fc8 100644
--- a/examples/13.recursion/03.recursive_spiral.pd
+++ b/examples/13.recursion/03.recursive_spiral.pd
@@ -11,7 +11,7 @@
 #X obj 14 243 rotate 45 0 0 1;
 #X obj 14 263 translate 2 0 1 0;
 #X text 170 17 A tutorial on recursion in Gem;
-#X text 170 37 (GPL) 2007 Claude Heiland-Allen <claudiusmaximus@goto10.org>
+#X text 170 37 (GPL) 2007 Claude Heiland-Allen <claude@mathr.co.uk>
 ;
 #X text 170 77 A common idiom in Gem is to use the [repeat] object
 found in the Zexy library \, to generate multiple copies of the same
diff --git a/examples/13.recursion/04.binary_tree.pd b/examples/13.recursion/04.binary_tree.pd
index 0550698..ef8f69f 100644
--- a/examples/13.recursion/04.binary_tree.pd
+++ b/examples/13.recursion/04.binary_tree.pd
@@ -6,7 +6,7 @@
 #X msg 55 33 destroy;
 #X obj 14 93 gemhead;
 #X text 170 17 A tutorial on recursion in Gem;
-#X text 170 37 (GPL) 2007 Claude Heiland-Allen <claudiusmaximus@goto10.org>
+#X text 170 37 (GPL) 2007 Claude Heiland-Allen <claude@mathr.co.uk>
 ;
 #X obj 24 163 r \$0-recurse;
 #X obj 68 133 v \$0-depth;
diff --git a/examples/13.recursion/05.n-ary_tree.pd b/examples/13.recursion/05.n-ary_tree.pd
index dca40cf..91d0565 100644
--- a/examples/13.recursion/05.n-ary_tree.pd
+++ b/examples/13.recursion/05.n-ary_tree.pd
@@ -6,7 +6,7 @@
 #X msg 55 33 destroy;
 #X obj 14 93 gemhead;
 #X text 170 17 A tutorial on recursion in Gem;
-#X text 170 37 (GPL) 2007 Claude Heiland-Allen <claudiusmaximus@goto10.org>
+#X text 170 37 (GPL) 2007 Claude Heiland-Allen <claude@mathr.co.uk>
 ;
 #X obj 30 159 r \$0-recurse;
 #X obj 68 133 v \$0-depth;
diff --git a/examples/13.recursion/06.breaking_symmetry.pd b/examples/13.recursion/06.breaking_symmetry.pd
index 74cd9c1..c409aaf 100644
--- a/examples/13.recursion/06.breaking_symmetry.pd
+++ b/examples/13.recursion/06.breaking_symmetry.pd
@@ -5,7 +5,7 @@
 #X msg 55 33 destroy;
 #X obj 14 92 gemhead;
 #X text 220 17 A tutorial on recursion in Gem;
-#X text 220 37 (GPL) 2007 Claude Heiland-Allen <claudiusmaximus@goto10.org>
+#X text 220 37 (GPL) 2007 Claude Heiland-Allen <claude@mathr.co.uk>
 ;
 #X obj 30 273 r \$0-recurse;
 #X obj 14 301 t a a;
diff --git a/examples/13.recursion/README b/examples/13.recursion/README
index 77fdbc9..90b5cf4 100644
--- a/examples/13.recursion/README
+++ b/examples/13.recursion/README
@@ -1,5 +1,5 @@
 gem-recursion -- a tutorial on using recursion with Gem
-Copyright (C) 2007 Claude Heiland-Allen <claudiusmaximus@goto10.org>
+Copyright (C) 2007 Claude Heiland-Allen <claude@mathr.co.uk>
 
 
 This program is free software; you can redistribute it and/or
diff --git a/examples/13.recursion/nnrepeat.pd b/examples/13.recursion/nnrepeat.pd
index 9ac5f37..c0e89d1 100644
--- a/examples/13.recursion/nnrepeat.pd
+++ b/examples/13.recursion/nnrepeat.pd
@@ -14,7 +14,7 @@
 #X obj 256 263 outlet;
 #X text 311 265 count;
 #X obj 132 209 print nnrepeat-internal-error;
-#X text 23 295 nnrepeat.pd (GPL) <claudiusmaximus@goto10.org>;
+#X text 23 295 nnrepeat.pd (GPL) <claude@mathr.co.uk>;
 #X connect 0 0 6 0;
 #X connect 0 1 7 0;
 #X connect 1 0 0 1;
diff --git a/examples/13.recursion/nrepeat.pd b/examples/13.recursion/nrepeat.pd
index 2281300..4d26d68 100644
--- a/examples/13.recursion/nrepeat.pd
+++ b/examples/13.recursion/nrepeat.pd
@@ -23,7 +23,7 @@
 #X text 233 23 count;
 #X text 8 225 repeated;
 #X text 119 381 counter;
-#X text 30 419 nrepeat.pd (GPL) <claudiusmaximus@goto10.org>;
+#X text 30 419 nrepeat.pd (GPL) <claude@mathr.co.uk>;
 #X connect 0 0 1 0;
 #X connect 1 0 7 0;
 #X connect 1 1 2 0;
diff --git a/examples/13.recursion/stack-help.pd b/examples/13.recursion/stack-help.pd
index 025fa74..b891067 100644
--- a/examples/13.recursion/stack-help.pd
+++ b/examples/13.recursion/stack-help.pd
@@ -11,7 +11,7 @@
 #X text 13 9 A stack is a "first in \, last out" structure.;
 #X text 13 48 Right inlet stores atom(s).;
 #X text 13 29 Left inlet unstores the most recently stored atom.;
-#X text 11 301 stack-help.pd (GPL) <claudiusmaximus@goto10.org>;
+#X text 11 301 stack-help.pd (GPL) <claude@mathr.co.uk>;
 #X connect 0 0 1 0;
 #X connect 0 1 2 0;
 #X connect 3 0 0 1;
diff --git a/examples/13.recursion/stack.pd b/examples/13.recursion/stack.pd
index ab47928..789ea8f 100644
--- a/examples/13.recursion/stack.pd
+++ b/examples/13.recursion/stack.pd
@@ -17,7 +17,7 @@
 #X obj 166 47 t b a b;
 #X obj 109 217 list prepend;
 #X obj 120 182 print stack-internal-error;
-#X text 17 330 stack.pd (GPL) <claudiusmaximus@goto10.org>;
+#X text 17 330 stack.pd (GPL) <claude@mathr.co.uk>;
 #X connect 0 0 4 0;
 #X connect 2 0 15 0;
 #X connect 4 0 11 0;
-- 
1.7.10.4