commit 4d62bb9276a1022fb6ae520d207cfff8b8629c21
Author: Jonathan Wilkes <jon.w.wilkes@gmail.com>
Date:   Fri Sep 4 11:55:43 2015 -0400

    zexy: add A_CANT to dsp method

diff --git a/externals/zexy/src/0x260x260x7e.c b/externals/zexy/src/0x260x260x7e.c
index fe8f36c..a93e56b 100644
--- a/externals/zexy/src/0x260x260x7e.c
+++ b/externals/zexy/src/0x260x260x7e.c
@@ -273,7 +273,7 @@ void setup_0x260x260x7e(void)
 {
   andand_tilde_class = class_new(gensym("&&~"), (t_newmethod)andand_tilde_new, 0,
 			   sizeof(t_andand_tilde), 0, A_GIMME, 0);
-  class_addmethod(andand_tilde_class, (t_method)andand_tilde_dsp, gensym("dsp"), 0);
+  class_addmethod(andand_tilde_class, (t_method)andand_tilde_dsp, gensym("dsp"), A_CANT, 0);
   CLASS_MAINSIGNALIN(andand_tilde_class, t_andand_tilde, x_f);
   class_addmethod  (andand_tilde_class, (t_method)andand_tilde_help, gensym("help"), A_NULL);
   class_sethelpsymbol(andand_tilde_class, gensym("zigbinops"));
diff --git a/externals/zexy/src/0x3c0x7e.c b/externals/zexy/src/0x3c0x7e.c
index 3a348bd..b05449d 100644
--- a/externals/zexy/src/0x3c0x7e.c
+++ b/externals/zexy/src/0x3c0x7e.c
@@ -232,7 +232,7 @@ void setup_0x3c0x7e(void)
 {
   lt_tilde_class = class_new(gensym("<~"), (t_newmethod)lt_tilde_new, 0,
 			    sizeof(t_lt_tilde), 0, A_GIMME, 0);
-  class_addmethod(lt_tilde_class, (t_method)lt_tilde_dsp, gensym("dsp"), 0);
+  class_addmethod(lt_tilde_class, (t_method)lt_tilde_dsp, gensym("dsp"), A_CANT, 0);
   CLASS_MAINSIGNALIN(lt_tilde_class, t_lt_tilde, x_f);
   class_addmethod  (lt_tilde_class, (t_method)lt_tilde_help, gensym("help"), A_NULL);
   class_sethelpsymbol(lt_tilde_class, gensym("zigbinops"));
diff --git a/externals/zexy/src/0x3d0x3d0x7e.c b/externals/zexy/src/0x3d0x3d0x7e.c
index 94211dd..4f77a3f 100644
--- a/externals/zexy/src/0x3d0x3d0x7e.c
+++ b/externals/zexy/src/0x3d0x3d0x7e.c
@@ -231,7 +231,7 @@ void setup_0x3d0x3d0x7e(void)
 {
   eq_tilde_class = class_new(gensym("==~"), (t_newmethod)eq_tilde_new, 0,
 			     sizeof(t_eq_tilde), 0, A_GIMME, 0);
-  class_addmethod(eq_tilde_class, (t_method)eq_tilde_dsp, gensym("dsp"), 0);
+  class_addmethod(eq_tilde_class, (t_method)eq_tilde_dsp, gensym("dsp"), A_CANT, 0);
   CLASS_MAINSIGNALIN(eq_tilde_class, t_eq_tilde, x_f);
   class_addmethod  (eq_tilde_class, (t_method)eq_tilde_help, gensym("help"), A_NULL);
   class_sethelpsymbol(eq_tilde_class, gensym("zigbinops"));
diff --git a/externals/zexy/src/0x3e0x7e.c b/externals/zexy/src/0x3e0x7e.c
index 766778d..ce137a0 100644
--- a/externals/zexy/src/0x3e0x7e.c
+++ b/externals/zexy/src/0x3e0x7e.c
@@ -235,7 +235,7 @@ void setup_0x3e0x7e(void)
 {
   gt_tilde_class = class_new(gensym(">~"), (t_newmethod)gt_tilde_new, 0,
 			   sizeof(t_gt_tilde), 0, A_GIMME, 0);
-  class_addmethod(gt_tilde_class, (t_method)gt_tilde_dsp, gensym("dsp"), 0);
+  class_addmethod(gt_tilde_class, (t_method)gt_tilde_dsp, gensym("dsp"), A_CANT, 0);
   CLASS_MAINSIGNALIN(gt_tilde_class, t_gt_tilde, x_f);
   class_addmethod  (gt_tilde_class, (t_method)gt_tilde_help, gensym("help"), A_NULL);
   class_sethelpsymbol(gt_tilde_class, gensym("zigbinops"));
diff --git a/externals/zexy/src/0x7c0x7c0x7e.c b/externals/zexy/src/0x7c0x7c0x7e.c
index e0cc4dd..7f1b387 100644
--- a/externals/zexy/src/0x7c0x7c0x7e.c
+++ b/externals/zexy/src/0x7c0x7c0x7e.c
@@ -249,7 +249,7 @@ void setup_0x7c0x7c0x7e(void)
 {
   oror_tilde_class = class_new(gensym("||~"), (t_newmethod)oror_tilde_new, 0,
 			  sizeof(t_oror_tilde), 0, A_GIMME, 0);
-  class_addmethod(oror_tilde_class, (t_method)oror_tilde_dsp, gensym("dsp"), 0);
+  class_addmethod(oror_tilde_class, (t_method)oror_tilde_dsp, gensym("dsp"), A_CANT, 0);
   CLASS_MAINSIGNALIN(oror_tilde_class, t_oror_tilde, x_f);
   class_addmethod  (oror_tilde_class, (t_method)oror_tilde_help, gensym("help"), A_NULL);
   class_sethelpsymbol(oror_tilde_class, gensym("zigbinops"));
diff --git a/externals/zexy/src/absgn~.c b/externals/zexy/src/absgn~.c
index a134aa5..1c7ec9a 100644
--- a/externals/zexy/src/absgn~.c
+++ b/externals/zexy/src/absgn~.c
@@ -134,7 +134,7 @@ void absgn_tilde_setup(void)
   sigABSGN_class = class_new(gensym("absgn~"), (t_newmethod)sigABSGN_new, 0,
                              sizeof(t_absgn), 0, A_DEFFLOAT, 0);
   CLASS_MAINSIGNALIN(sigABSGN_class, t_absgn, x_f);
-  class_addmethod(sigABSGN_class, (t_method)sigABSGN_dsp, gensym("dsp"), 0);
+  class_addmethod(sigABSGN_class, (t_method)sigABSGN_dsp, gensym("dsp"), A_CANT, 0);
   
   class_addmethod(sigABSGN_class, (t_method)sigABSGN_helper, gensym("help"), 0);
   class_sethelpsymbol(sigABSGN_class, gensym("zigbinops"));
diff --git a/externals/zexy/src/abs~.c b/externals/zexy/src/abs~.c
index 0d509f9..1e59bd0 100644
--- a/externals/zexy/src/abs~.c
+++ b/externals/zexy/src/abs~.c
@@ -152,7 +152,7 @@ void abs_tilde_setup(void)
   sigABS_class = class_new(gensym("abs~"), (t_newmethod)sigABS_new, 0,
 			   sizeof(t_abs), 0, A_DEFFLOAT, 0);
   CLASS_MAINSIGNALIN(sigABS_class, t_abs, x_f);
-  class_addmethod(sigABS_class, (t_method)sigABS_dsp, gensym("dsp"), 0);
+  class_addmethod(sigABS_class, (t_method)sigABS_dsp, gensym("dsp"), A_CANT, 0);
   
   class_addmethod(sigABS_class, (t_method)sigABS_helper, gensym("help"), 0);
   class_sethelpsymbol(sigABS_class, gensym("zigbinops"));
diff --git a/externals/zexy/src/avg~.c b/externals/zexy/src/avg~.c
index 6254520..9ecdc20 100644
--- a/externals/zexy/src/avg~.c
+++ b/externals/zexy/src/avg~.c
@@ -78,7 +78,7 @@ void avg_tilde_setup(void)
   avg_class = class_new(gensym("avg~"), (t_newmethod)avg_new, 0,
                         sizeof(t_avg), 0, A_DEFFLOAT, 0);
   class_addmethod(avg_class, nullfn, gensym("signal"), 0);
-  class_addmethod(avg_class, (t_method)avg_dsp, gensym("dsp"), 0);
+  class_addmethod(avg_class, (t_method)avg_dsp, gensym("dsp"), A_CANT, 0);
 
   class_addmethod(avg_class, (t_method)avg_help, gensym("help"), 0);
   zexy_register("avg~");
diff --git a/externals/zexy/src/blockmirror~.c b/externals/zexy/src/blockmirror~.c
index c796d7b..0d89baa 100644
--- a/externals/zexy/src/blockmirror~.c
+++ b/externals/zexy/src/blockmirror~.c
@@ -100,7 +100,7 @@ void blockmirror_tilde_setup(void)
                                 (t_method)blockmirror_free,
                                 sizeof(t_blockmirror), 0, A_NULL);
   class_addmethod(blockmirror_class, nullfn, gensym("signal"), 0);
-  class_addmethod(blockmirror_class, (t_method)blockmirror_dsp, gensym("dsp"), 0);
+  class_addmethod(blockmirror_class, (t_method)blockmirror_dsp, gensym("dsp"), A_CANT, 0);
   
   class_addfloat(blockmirror_class, blockmirror_float);
   
diff --git a/externals/zexy/src/blockshuffle~.c b/externals/zexy/src/blockshuffle~.c
index db2a0d6..273ab7f 100644
--- a/externals/zexy/src/blockshuffle~.c
+++ b/externals/zexy/src/blockshuffle~.c
@@ -137,7 +137,7 @@ void blockshuffle_tilde_setup(void)
                                  (t_method)blockshuffle_free,
                                  sizeof(t_blockshuffle), 0, A_NULL);
   class_addmethod(blockshuffle_class, nullfn, gensym("signal"), 0);
-  class_addmethod(blockshuffle_class, (t_method)blockshuffle_dsp, gensym("dsp"), 0);
+  class_addmethod(blockshuffle_class, (t_method)blockshuffle_dsp, gensym("dsp"), A_CANT, 0);
   
   class_addlist(blockshuffle_class, blockshuffle_list);
   
diff --git a/externals/zexy/src/blockswap~.c b/externals/zexy/src/blockswap~.c
index deb9ce2..95ee08f 100644
--- a/externals/zexy/src/blockswap~.c
+++ b/externals/zexy/src/blockswap~.c
@@ -100,7 +100,7 @@ void blockswap_tilde_setup(void)
   blockswap_class = class_new(gensym("blockswap~"), (t_newmethod)blockswap_new, (t_method)blockswap_free,
                               sizeof(t_blockswap), 0, A_NULL);
   class_addmethod(blockswap_class, nullfn, gensym("signal"), 0);
-  class_addmethod(blockswap_class, (t_method)blockswap_dsp, gensym("dsp"), 0);
+  class_addmethod(blockswap_class, (t_method)blockswap_dsp, gensym("dsp"), A_CANT, 0);
   
   class_addfloat(blockswap_class, blockswap_float);
   
diff --git a/externals/zexy/src/demultiplex~.c b/externals/zexy/src/demultiplex~.c
index 7d5f0b3..ba1d367 100644
--- a/externals/zexy/src/demultiplex~.c
+++ b/externals/zexy/src/demultiplex~.c
@@ -106,7 +106,7 @@ void demultiplex_tilde_setup(void)
   class_addcreator((t_newmethod)demux_new, gensym("demux~"), A_GIMME, 0);
 
   class_addfloat(demux_class, demux_output);
-  class_addmethod(demux_class, (t_method)demux_dsp, gensym("dsp"), 0);
+  class_addmethod(demux_class, (t_method)demux_dsp, gensym("dsp"), A_CANT, 0);
   class_addmethod(demux_class, nullfn, gensym("signal"), 0);
 
   class_addmethod(demux_class, (t_method)demux_helper, gensym("help"), 0);
diff --git a/externals/zexy/src/dfreq~.c b/externals/zexy/src/dfreq~.c
index 3e87567..4afe3d0 100644
--- a/externals/zexy/src/dfreq~.c
+++ b/externals/zexy/src/dfreq~.c
@@ -110,7 +110,7 @@ void dfreq_tilde_setup(void)
   dfreq_class = class_new(gensym("dfreq~"), (t_newmethod)dfreq_new, 0,
                           sizeof(t_dfreq), 0, A_NULL);
   class_addmethod(dfreq_class, nullfn, gensym("signal"), 0);
-  class_addmethod(dfreq_class, (t_method)dfreq_dsp, gensym("dsp"), 0);
+  class_addmethod(dfreq_class, (t_method)dfreq_dsp, gensym("dsp"), A_CANT, 0);
 
   class_addmethod(dfreq_class, (t_method)dfreq_tilde_helper, gensym("help"), 0);
   zexy_register("dfreq~");
diff --git a/externals/zexy/src/dirac~.c b/externals/zexy/src/dirac~.c
index 3213c82..3665ed5 100644
--- a/externals/zexy/src/dirac~.c
+++ b/externals/zexy/src/dirac~.c
@@ -152,7 +152,7 @@ void dirac_tilde_setup(void)
                           sizeof(t_dirac), 0, A_DEFFLOAT, 0);
   class_addfloat(dirac_class, dirac_float); 
   class_addbang(dirac_class, dirac_bang); 
-  class_addmethod(dirac_class, (t_method)dirac_dsp, gensym("dsp"), 0);
+  class_addmethod(dirac_class, (t_method)dirac_dsp, gensym("dsp"), A_CANT, 0);
 
   class_addmethod(dirac_class, (t_method)dirac_helper, gensym("help"), 0);
   zexy_register("dirac~");
diff --git a/externals/zexy/src/envrms~.c b/externals/zexy/src/envrms~.c
index 263c2a9..cae3d8c 100644
--- a/externals/zexy/src/envrms~.c
+++ b/externals/zexy/src/envrms~.c
@@ -144,7 +144,7 @@ void envrms_tilde_setup(void)
   sigenvrms_class = class_new(gensym("envrms~"), (t_newmethod)sigenvrms_new,
                               (t_method)sigenvrms_ff, sizeof(t_sigenvrms), 0, A_DEFFLOAT, A_DEFFLOAT, 0);
   class_addmethod(sigenvrms_class, nullfn, gensym("signal"), 0);
-  class_addmethod(sigenvrms_class, (t_method)sigenvrms_dsp, gensym("dsp"), 0);
+  class_addmethod(sigenvrms_class, (t_method)sigenvrms_dsp, gensym("dsp"), A_CANT, 0);
 
   class_addmethod(sigenvrms_class, (t_method)sigenvrms_help, gensym("help"), 0);
   zexy_register("envrms~");
diff --git a/externals/zexy/src/limiter~.c b/externals/zexy/src/limiter~.c
index 8c930f9..ca6cb11 100644
--- a/externals/zexy/src/limiter~.c
+++ b/externals/zexy/src/limiter~.c
@@ -734,7 +734,7 @@ void limiter_tilde_setup(void)
 			    sizeof(t_limiter), 0, A_GIMME, 0);
 
   class_addmethod(limiter_class, nullfn,					gensym("signal"), 0);
-  class_addmethod(limiter_class, (t_method)limiter_dsp,	gensym("dsp"), 0);
+  class_addmethod(limiter_class, (t_method)limiter_dsp,	gensym("dsp"), A_CANT, 0);
 
   class_addmethod(limiter_class, (t_method)limiter_tilde_helper,	gensym("help"), 0);
   class_addmethod(limiter_class, (t_method)status,	gensym("print"), 0);
diff --git a/externals/zexy/src/multiline~.c b/externals/zexy/src/multiline~.c
index 6dc7f0d..4b85859 100644
--- a/externals/zexy/src/multiline~.c
+++ b/externals/zexy/src/multiline~.c
@@ -260,7 +260,7 @@ void multiline_tilde_setup(void)
   mline_class = class_new(gensym("multiline~"), (t_newmethod)mline_new, (t_method)mline_free,
 			  sizeof(t_mline), 0, A_GIMME, 0);
 
-  class_addmethod(mline_class, (t_method)mline_dsp, gensym("dsp"), 0);
+  class_addmethod(mline_class, (t_method)mline_dsp, gensym("dsp"), A_CANT, 0);
   class_addmethod(mline_class, nullfn, gensym("signal"), 0);
 
   class_addmethod(mline_class, (t_method)mline_list, gensym(""), A_GIMME, 0);
diff --git a/externals/zexy/src/multiplex~.c b/externals/zexy/src/multiplex~.c
index 82d76d5..50cbf1c 100644
--- a/externals/zexy/src/multiplex~.c
+++ b/externals/zexy/src/multiplex~.c
@@ -101,7 +101,7 @@ void multiplex_tilde_setup(void)
   class_addcreator((t_newmethod)mux_tilde_new, gensym("mux~"), A_GIMME, 0);
 
   class_addfloat(mux_tilde_class, mux_tilde_input);
-  class_addmethod(mux_tilde_class, (t_method)mux_tilde_dsp, gensym("dsp"), 0);
+  class_addmethod(mux_tilde_class, (t_method)mux_tilde_dsp, gensym("dsp"), A_CANT, 0);
   class_addmethod(mux_tilde_class, nullfn, gensym("signal"), 0);
 
   class_addmethod(mux_tilde_class, (t_method)mux_tilde_helper, gensym("help"), 0);
diff --git a/externals/zexy/src/noish~.c b/externals/zexy/src/noish~.c
index 8d5c875..1deef4d 100644
--- a/externals/zexy/src/noish~.c
+++ b/externals/zexy/src/noish~.c
@@ -185,7 +185,7 @@ void noish_tilde_setup(void)
   noish_class = class_new(gensym("noish~"), (t_newmethod)noish_new, 0, sizeof(t_nois), 0, A_DEFFLOAT, 0);
 
   class_addfloat(noish_class, set_freq);
-  class_addmethod(noish_class, (t_method)noish_dsp, gensym("dsp"), 0);
+  class_addmethod(noish_class, (t_method)noish_dsp, gensym("dsp"), A_CANT, 0);
 
   class_addmethod(noish_class, (t_method)set_noisseed, gensym("seed"), A_FLOAT, 0);
 
diff --git a/externals/zexy/src/noisi~.c b/externals/zexy/src/noisi~.c
index d815b21..d775682 100644
--- a/externals/zexy/src/noisi~.c
+++ b/externals/zexy/src/noisi~.c
@@ -170,7 +170,7 @@ void noisi_tilde_setup(void){
   noisi_class = class_new(gensym("noisi~"), (t_newmethod)noisi_new, 0, sizeof(t_nois), 0, A_DEFFLOAT, 0);
 
   class_addfloat(noisi_class, set_noisfreq);
-  class_addmethod(noisi_class, (t_method)noisi_dsp, gensym("dsp"), 0);
+  class_addmethod(noisi_class, (t_method)noisi_dsp, gensym("dsp"), A_CANT, 0);
 
   class_addmethod(noisi_class, (t_method)set_noisseed, gensym("seed"), A_FLOAT, 0);
 
diff --git a/externals/zexy/src/pack~.c b/externals/zexy/src/pack~.c
index 89901b3..3ad5743 100644
--- a/externals/zexy/src/pack~.c
+++ b/externals/zexy/src/pack~.c
@@ -95,7 +95,7 @@ void pack_tilde_setup(void)
   sigpack_class = class_new(gensym("pack~"), (t_newmethod)sigpack_new, (t_method)sigpack_free,
                             sizeof(t_sigpack), 0, A_DEFFLOAT, 0);
   class_addmethod(sigpack_class, nullfn, gensym("signal"), 0);
-  class_addmethod(sigpack_class, (t_method)sigpack_dsp, gensym("dsp"), 0);
+  class_addmethod(sigpack_class, (t_method)sigpack_dsp, gensym("dsp"), A_CANT, 0);
 
   class_addmethod(sigpack_class, (t_method)sigpack_help, gensym("help"), 0);
 
diff --git a/externals/zexy/src/pdf~.c b/externals/zexy/src/pdf~.c
index aee193c..a0d76ca 100644
--- a/externals/zexy/src/pdf~.c
+++ b/externals/zexy/src/pdf~.c
@@ -128,7 +128,7 @@ void pdf_tilde_setup(void)
 			sizeof(t_pdf), 0, A_DEFFLOAT, 0);
 
   class_addmethod(pdf_class, nullfn, gensym("signal"), 0);
-  class_addmethod(pdf_class, (t_method)pdf_dsp, gensym("dsp"), 0);
+  class_addmethod(pdf_class, (t_method)pdf_dsp, gensym("dsp"), A_CANT, 0);
 
   class_addmethod(pdf_class, (t_method)pdf_bang, gensym("bang"), 0);
   class_addmethod(pdf_class, (t_method)clear_pdfbuf, gensym("clear"), 0);
diff --git a/externals/zexy/src/quantize~.c b/externals/zexy/src/quantize~.c
index b561243..0339e7b 100644
--- a/externals/zexy/src/quantize~.c
+++ b/externals/zexy/src/quantize~.c
@@ -103,7 +103,7 @@ void quantize_tilde_setup(void)
   quantize_class = class_new(gensym("quantize~"), (t_newmethod)quantize_new, 0,
 			     sizeof(t_quantize), 0, A_DEFFLOAT, 0);
   class_addmethod(quantize_class, nullfn, gensym("signal"), 0);
-  class_addmethod(quantize_class, (t_method)quantize_dsp, gensym("dsp"), 0);
+  class_addmethod(quantize_class, (t_method)quantize_dsp, gensym("dsp"), A_CANT, 0);
 
   class_addfloat(quantize_class, quantize_float);
   class_addmethod(quantize_class, (t_method)quantize_8bit, gensym("8bit"), 0);
diff --git a/externals/zexy/src/sfplay.c b/externals/zexy/src/sfplay.c
index b5db0b3..9c3a469 100644
--- a/externals/zexy/src/sfplay.c
+++ b/externals/zexy/src/sfplay.c
@@ -647,7 +647,7 @@ void sfplay_setup(void)
    sfplay_class = class_new(gensym("sfplay"), (t_newmethod)sfplay_new, (t_method)sfplay_free,
       sizeof(t_sfplay), 0, A_DEFFLOAT, A_DEFFLOAT,0);
    class_addmethod(sfplay_class, nullfn, gensym("signal"), 0);
-   class_addmethod(sfplay_class, (t_method)sfplay_dsp, gensym("dsp"), 0);
+   class_addmethod(sfplay_class, (t_method)sfplay_dsp, gensym("dsp"), A_CANT, 0);
 
    class_addmethod(sfplay_class, (t_method)sfplay_helper, gensym("help"), A_NULL);
    class_sethelpsymbol(sfplay_class, gensym("sf-play_record"));
diff --git a/externals/zexy/src/sfrecord.c b/externals/zexy/src/sfrecord.c
index b4329ce..c3d921a 100644
--- a/externals/zexy/src/sfrecord.c
+++ b/externals/zexy/src/sfrecord.c
@@ -586,7 +586,7 @@ void sfrecord_setup(void)
 	sfrecord_class = class_new(gensym("sfrecord"), (t_newmethod)sfrecord_new, (t_method)sfrecord_free,
 		sizeof(t_sfrecord), 0, A_DEFFLOAT, A_DEFFLOAT,0);
 	class_addmethod(sfrecord_class, nullfn, gensym("signal"), 0);
-	class_addmethod(sfrecord_class, (t_method)sfrecord_dsp, gensym("dsp"), 0);
+	class_addmethod(sfrecord_class, (t_method)sfrecord_dsp, gensym("dsp"), A_CANT, 0);
 
 	/* method open with filename */
 	class_addmethod(sfrecord_class, (t_method)sfrecord_open, gensym("open"), A_SYMBOL,A_SYMBOL,A_NULL);
diff --git a/externals/zexy/src/sgn~.c b/externals/zexy/src/sgn~.c
index 2570fd2..1b5ab96 100644
--- a/externals/zexy/src/sgn~.c
+++ b/externals/zexy/src/sgn~.c
@@ -146,7 +146,7 @@ void sgn_tilde_setup(void)
   sgnTilde_class = class_new(gensym("sgn~"), (t_newmethod)sgnTilde_new, 0,
                              sizeof(t_sgnTilde), 0, A_DEFFLOAT, 0);
   class_addmethod(sgnTilde_class, nullfn, gensym("signal"), 0);
-  class_addmethod(sgnTilde_class, (t_method)sgnTilde_dsp, gensym("dsp"), 0);
+  class_addmethod(sgnTilde_class, (t_method)sgnTilde_dsp, gensym("dsp"), A_CANT, 0);
   
   class_addmethod(sgnTilde_class, (t_method)sgnTilde_helper, gensym("help"), 0);
   class_sethelpsymbol(sgnTilde_class, gensym("zigbinops"));
diff --git a/externals/zexy/src/sigzero~.c b/externals/zexy/src/sigzero~.c
index e78f1a0..b675eea 100644
--- a/externals/zexy/src/sigzero~.c
+++ b/externals/zexy/src/sigzero~.c
@@ -106,7 +106,7 @@ void sigzero_tilde_setup(void)
   class_addmethod(sigzero_class, (t_method)sigzero_off, gensym("off"), 0);
 
   class_addmethod(sigzero_class, nullfn, gensym("signal"), 0);
-  class_addmethod(sigzero_class, (t_method)sigzero_dsp, gensym("dsp"), 0);
+  class_addmethod(sigzero_class, (t_method)sigzero_dsp, gensym("dsp"), A_CANT, 0);
 
   class_addmethod(sigzero_class, (t_method)sigzero_tilde_helper, gensym("help"), 0);
   zexy_register("sigzero~");
diff --git a/externals/zexy/src/step~.c b/externals/zexy/src/step~.c
index 4558819..8407a13 100644
--- a/externals/zexy/src/step~.c
+++ b/externals/zexy/src/step~.c
@@ -136,7 +136,7 @@ void step_tilde_setup(void)
   class_addfloat(step_class, step_float);
   class_addbang(step_class, step_bang); 
   class_addmethod(step_class, (t_method)step_setlength, gensym("ft1"), A_FLOAT, 0);
-  class_addmethod(step_class, (t_method)step_dsp, gensym("dsp"), 0);
+  class_addmethod(step_class, (t_method)step_dsp, gensym("dsp"), A_CANT, 0);
 
   class_addmethod(step_class, (t_method)step_helper, gensym("help"), 0);
 
diff --git a/externals/zexy/src/swap~.c b/externals/zexy/src/swap~.c
index 05fd4b9..189e6cf 100644
--- a/externals/zexy/src/swap~.c
+++ b/externals/zexy/src/swap~.c
@@ -94,7 +94,7 @@ void swap_tilde_setup(void)
   swap_class = class_new(gensym("swap~"), (t_newmethod)swap_new, 0,
 			 sizeof(t_swap), 0, A_NULL);
   class_addmethod(swap_class, nullfn, gensym("signal"), 0);
-  class_addmethod(swap_class, (t_method)swap_dsp, gensym("dsp"), 0);
+  class_addmethod(swap_class, (t_method)swap_dsp, gensym("dsp"), A_CANT, 0);
   
   class_addfloat(swap_class, swap_float);
   class_addbang(swap_class, swap_bang);
diff --git a/externals/zexy/src/tabread4~~.c b/externals/zexy/src/tabread4~~.c
index 6c53508..375df38 100644
--- a/externals/zexy/src/tabread4~~.c
+++ b/externals/zexy/src/tabread4~~.c
@@ -133,7 +133,7 @@ void tabread4_tilde_tilde_setup(void)
                                    sizeof(t_tabread4_tilde), 0, A_DEFSYM, 0);
   CLASS_MAINSIGNALIN(tabread4_tilde_class, t_tabread4_tilde, x_f);
   class_addmethod(tabread4_tilde_class, (t_method)tabread4_tilde_dsp,
-                  gensym("dsp"), 0);
+                  gensym("dsp"), A_CANT, 0);
   class_addmethod(tabread4_tilde_class, (t_method)tabread4_tilde_set,
                   gensym("set"), A_SYMBOL, 0);
 
diff --git a/externals/zexy/src/tavg~.c b/externals/zexy/src/tavg~.c
index 0d0231a..2671297 100644
--- a/externals/zexy/src/tavg~.c
+++ b/externals/zexy/src/tavg~.c
@@ -77,7 +77,7 @@ void tavg_tilde_setup(void)
   tavg_class = class_new(gensym("tavg~"), (t_newmethod)tavg_new, 0,
                          sizeof(t_tavgtilde), 0, A_DEFFLOAT, 0);
   class_addmethod(tavg_class, nullfn, gensym("signal"), 0);
-  class_addmethod(tavg_class, (t_method)tavg_dsp, gensym("dsp"), 0);
+  class_addmethod(tavg_class, (t_method)tavg_dsp, gensym("dsp"), A_CANT, 0);
 
   class_addbang(tavg_class, tavg_bang);
 
diff --git a/externals/zexy/src/unpack~.c b/externals/zexy/src/unpack~.c
index 7745e2c..040ce64 100644
--- a/externals/zexy/src/unpack~.c
+++ b/externals/zexy/src/unpack~.c
@@ -114,7 +114,7 @@ void unpack_tilde_setup(void)
 {
   sigunpack_class = class_new(gensym("unpack~"), (t_newmethod)sigunpack_new, 0,
                               sizeof(t_sigunpack), 0, A_DEFFLOAT, 0);
-  class_addmethod(sigunpack_class, (t_method)sigunpack_dsp, gensym("dsp"), 0);
+  class_addmethod(sigunpack_class, (t_method)sigunpack_dsp, gensym("dsp"), A_CANT, 0);
   class_addfloat(sigunpack_class, (t_method)sigunpack_float);
   class_addlist (sigunpack_class, (t_method)sigunpack_list);
 
diff --git a/externals/zexy/src/z~.c b/externals/zexy/src/z~.c
index 1bf3435..5f6f4d3 100644
--- a/externals/zexy/src/z~.c
+++ b/externals/zexy/src/z~.c
@@ -127,7 +127,7 @@ void z_tilde_setup(void)
   zNdelay_class = class_new(gensym("z~"), (t_newmethod)zNdelay_new, (t_method)zNdelay_free,
 			    sizeof(t_zNdelay), 0, A_DEFFLOAT, 0);
   class_addmethod(zNdelay_class, nullfn, gensym("signal"), 0);
-  class_addmethod(zNdelay_class, (t_method)zNdelay_dsp, gensym("dsp"), 0);
+  class_addmethod(zNdelay_class, (t_method)zNdelay_dsp, gensym("dsp"), A_CANT, 0);
 
   class_addfloat(zNdelay_class, zdel_float);
   class_addmethod(zNdelay_class, (t_method)zdel_float, gensym("ft1"), A_FLOAT, 0);